#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

typedef char CASELLA;
typedef char POSIZIONE;
typedef struct structcouple { POSIZIONE val[2]; } couple;
typedef struct structgriglia { CASELLA c[9][9]; } griglia;

griglia grigliainiziale, grigliafinale;

void clear(griglia* g);
void stampa(griglia* g);
void stampa2griglie(griglia* g1, griglia* g2);
int leggi_da_console(griglia* g);
int valido(griglia* g);
int valido_fast(griglia* g, int r, int c);
int trovaLibero(griglia* g, couple* pos);
int prova(griglia* g1, griglia* g2, int livello);

unsigned int size=9;
int test[10];

void clear(griglia* g){
  unsigned int i, j;
  for (i=0;i<9;i++){
    for (j=0;j<9;j++){
      g->c[i][j]=0;
    }
  }
}

void stampa(griglia* g){
  unsigned int i;
  unsigned int j;
  for (i=0; i<9; i++){
    if(!(i%3)){ puts("+---+---+---+"); }
    for (j=0;j<9;j++){
      if(!(j%3)){ putchar('!'); }
      putchar((g->c[i][j]>0)?g->c[i][j]+'0':' ');        
    }    
    puts("!");
  }
  puts("+---+---+---+");  
}

void stampa2griglie(griglia* g1, griglia* g2){
  unsigned int i;
  unsigned int j;
  unsigned int k;
  for (i=0; i<9; i++){
    if(!(i%3)){ puts("+---+---+---+   +---+---+---+"); }
    for (j=0;j<9;j++){
      if(!(j%3)){ putchar('!'); }
      putchar((g1->c[i][j]>0)?g1->c[i][j]+'0':' ');        
    }
    for (k=0; k<4; k++) putchar((k==0)?'!':' ');
    for (j=0;j<9;j++){
      if(!(j%3)){ putchar('!'); }
      putchar((g2->c[i][j]>0)?g2->c[i][j]+'0':' ');        
    }        
    puts("!");
  }
  puts("+---+---+---+   +---+---+---+");  
}

int leggi_da_console(griglia* g){
  char riga[40];
  char tmp;
  unsigned int i;
  unsigned int j;
  for (i=0; i<9; i++){
    gets(riga);
    for (j=0;j<9;j++){
	    tmp=riga[j]-'0';
	    if (tmp<0 || tmp>9) return 0;
      g->c[i][j]=(CASELLA)tmp;
    }
  }
  return 1;
}

int valido(griglia* g){
  unsigned int i,j;

  for (i=0;i<size;i++){
    for (j=0;j<=9;j++){ test[j]=0; }
    for (j=0;j<size;j++){ test[g->c[i][j]]+=1; }
    for (j=1;j<=9;j++){ if(test[j]>1) return 0; }

    for (j=0;j<=9;j++){ test[j]=0; }
    for (j=0;j<size;j++){ test[g->c[j][i]]+=1; }
    for (j=1;j<=9;j++){ if(test[j]>1) return 0; }

    for (j=0;j<=9;j++){ test[j]=0; }
    for (j=0;j<size;j++){ test[g->c[3*(i/3)+j/3][3*(i%3)+j%3]]+=1; }
    for (j=1;j<=9;j++){ if(test[j]>1) return 0; }
  }
  return 1;
}

int valido_fast(griglia* g, int r, int c){
  unsigned int j;

  for (j=0;j<=9;j++){ test[j]=0; }
  for (j=0;j<size;j++){ test[g->c[r][j]]+=1; }
  for (j=1;j<=9;j++){ if(test[j]>1) return 0; }

  for (j=0;j<=9;j++){ test[j]=0; }
  for (j=0;j<size;j++){ test[g->c[j][c]]+=1; }
  for (j=1;j<=9;j++){ if(test[j]>1) return 0; }

  for (j=0;j<=9;j++){ test[j]=0; }
  for (j=0;j<size;j++){ test[g->c[3*(r/3)+j/3][3*(c/3)+j%3]]+=1; }
  for (j=1;j<=9;j++){ if(test[j]>1) return 0; }

  return 1;
}

int trovaLibero(griglia* g, couple* ret){
  unsigned int i;
  unsigned int j;
  for (i=0;i<size;i++){
    for(j=0;j<size;j++){
      if (g->c[i][j]==0){
        ret->val[0]=i;
        ret->val[1]=j;
        return 1;
      }
    }
  }
  return 0;
}

int prova(griglia* g1, griglia* g2, int livello){
  couple pos;
  int k;
  if (livello<0){ return 1; }
  if (trovaLibero(g2,&pos)==0){
    puts("A solution has been found:");
    puts("==========================");
    puts("");
    stampa2griglie(g1, g2);
    return 1;
  } else {
    for (k=1;k<=9;k++){
      g2->c[pos.val[0]][pos.val[1]]=k;
      if (
        valido_fast(g2,pos.val[0],pos.val[1]) &&
        prova(g1,g2,livello-1)           ){
        return 1;
      }
      g2->c[pos.val[0]][pos.val[1]]=0;
    }
  }  
  return 0;
}

int main(){
  clear(&grigliainiziale);
  clear(&grigliafinale);
  if (!leggi_da_console(&grigliainiziale)){
    puts("Error: wrong data in input");
    return 1;
  } else {
    if (!valido(&grigliainiziale)){
      puts("Error: wrong Sudoku numbers in grid");
      return 2;
    } else {
	    memcpy(&grigliafinale, &grigliainiziale, sizeof(griglia));
	    puts("");
      puts("Starting grid");
      puts("-------------");
			puts("");
			stampa(&grigliainiziale);
			puts("");
      prova(&grigliainiziale, &grigliafinale, size*size);
    }
  }
  return 0;
}


